import time
from struct import *

class ref: #Acts as a reference variable
    def __init__(self, obj):
        self.obj = obj
    def get(self):
        return self.obj
    def set(self, obj):
        self.obj = obj
    
def bin_to_dec(dump):
    return map(ord, dump) #USE map(ord, hex dump) to convert the dump to a list of values
    
def average(dump, div=None):
    if div is None:
        div = float(len(dump))
    return sum(dump) / div
    
def convert_to_volt(x, v_range):
    y = float(x) - 128.0
    return (y * (float(v_range) / 256.0))

def convert_to_volt_12bit(x, v_range):
    return x * float(v_range)

def avg_dump_12bit(dump): #Even faster
    dump_len = len(dump)
    dump_len_arg = ">" + str(dump_len / 2) + "h"
    try:
        new = unpack(dump_len_arg, dump)
        f_top = False
        f_bot = False
        
        if (max(new) > (32767 - 72)): #Clipping top WHY 72?!?!?!
            f_top = True
            
        if (min(new) < (-32768 + 32)): #Clipping bottom
            f_bot = True

        avg = sum(new) / len(new)
    except:
        avg = 1
        f_bot, f_top = True, True

    return avg / 65536.0, (f_top, f_bot)
